Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -892,434 +1083,351 @@
   char tmps1[1024];
 
-  r_inputs=NULL;
-  r_inputs=getMap(request_inputs,"metapath");
-  if(r_inputs!=NULL)
-    snprintf(conf_dir,1024,"%s/%s",ntmp,r_inputs->value);
+  r_inputs = NULL;
+  r_inputs = getMap (request_inputs, "metapath");
+  if (r_inputs != NULL)
+    snprintf (conf_dir, 1024, "%s/%s", ntmp, r_inputs->value);
   else
-    snprintf(conf_dir,1024,"%s",ntmp);
-
-  if(strncasecmp(REQUEST,"GetCapabilities",15)==0){
-#ifdef DEBUG
-    dumpMap(r_inputs);
-#endif
-    xmlDocPtr doc = xmlNewDoc(BAD_CAST "1.0");
-    r_inputs=NULL;
-    r_inputs=getMap(request_inputs,"ServiceProvider");
-    xmlNodePtr n;
-    if(r_inputs!=NULL)
-      n = printGetCapabilitiesHeader(doc,r_inputs->value,m);
-    else
-      n = printGetCapabilitiesHeader(doc,"",m);
+    snprintf (conf_dir, 1024, "%s", ntmp);
+
+  if (strncasecmp (REQUEST, "GetCapabilities", 15) == 0)
+    {
+#ifdef DEBUG
+      dumpMap (r_inputs);
+#endif
+      xmlDocPtr doc = xmlNewDoc (BAD_CAST "1.0");
+      r_inputs = NULL;
+      r_inputs = getMap (request_inputs, "ServiceProvider");
+      xmlNodePtr n;
+      if (r_inputs != NULL)
+        n = printGetCapabilitiesHeader (doc, r_inputs->value, m);
+      else
+        n = printGetCapabilitiesHeader (doc, "", m);
     /**
      * Here we need to close stdout to ensure that not supported chars 
      * has been found in the zcfg and then printed on stdout
      */
-    int saved_stdout = dup(fileno(stdout));
-    dup2(fileno(stderr),fileno(stdout));
-    if(int res=recursReaddirF(m,n,conf_dir,NULL,saved_stdout,0,printGetCapabilitiesForProcess)<0){
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      free(SERVICE_URL);
-      fflush(stdout);
-      return res;
-    }
-    dup2(saved_stdout,fileno(stdout));
-    printDocument(m,doc,getpid());
-    freeMaps(&m);
-    free(m);
-    free(REQUEST);
-    free(SERVICE_URL);
-    fflush(stdout);
-    return 0;
-  }
-  else{
-    r_inputs=getMap(request_inputs,"Identifier");
-    if(r_inputs==NULL 
-       || strlen(r_inputs->name)==0 || strlen(r_inputs->value)==0){ 
-      errorException(m, _("Mandatory <identifier> was not specified"),"MissingParameterValue","identifier");
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      free(SERVICE_URL);
+      int saved_stdout = dup (fileno (stdout));
+      dup2 (fileno (stderr), fileno (stdout));
+
+        /**
+      if (int res =
+          recursReaddirF (m, n, conf_dir, NULL, saved_stdout, 0,
+                          printGetCapabilitiesForProcess) < 0)
+        {
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          free (SERVICE_URL);
+          fflush (stdout);
+          return res;
+        }
+      **/
+      XML_CapabilitiesAllProcess (m, n);
+      dup2 (saved_stdout, fileno (stdout));
+      printDocument (m, doc, getpid ());
+      freeMaps (&m);
+      free (m);
+      free (REQUEST);
+      free (SERVICE_URL);
+      fflush (stdout);
       return 0;
     }
-
-    struct dirent *dp;
-    DIR *dirp = opendir(conf_dir);
-    if(dirp==NULL){
-      errorException(m, _("The specified path path doesn't exist."),"InvalidParameterValue",conf_dir);
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      free(SERVICE_URL);
-      return 0;
-    }
-    if(strncasecmp(REQUEST,"DescribeProcess",15)==0){
+  else
+    {
+      r_inputs = getMap (request_inputs, "Identifier");
+      if (r_inputs == NULL
+          || strlen (r_inputs->name) == 0 || strlen (r_inputs->value) == 0)
+        {
+          errorException (m, _("Mandatory <identifier> was not specified"),
+                          "MissingParameterValue", "identifier");
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          free (SERVICE_URL);
+          return 0;
+        }
+
+      struct dirent *dp;
+      DIR *dirp = opendir (conf_dir);
+      if (dirp == NULL)
+        {
+          errorException (m, _("The specified path path doesn't exist."),
+                          "InvalidParameterValue", conf_dir);
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          free (SERVICE_URL);
+          return 0;
+        }
+      if (strncasecmp (REQUEST, "DescribeProcess", 15) == 0)
+        {
       /**
        * Loop over Identifier list
        */
-      xmlDocPtr doc = xmlNewDoc(BAD_CAST "1.0");
-      r_inputs=NULL;
-      r_inputs=getMap(request_inputs,"ServiceProvider");
-
-      xmlNodePtr n;
-      if(r_inputs!=NULL)
-	n = printDescribeProcessHeader(doc,r_inputs->value,m);
-      else
-	n = printDescribeProcessHeader(doc,"",m);
-
-      r_inputs=getMap(request_inputs,"Identifier");
-      
-      char *orig=zStrdup(r_inputs->value);
-
-      int saved_stdout = dup(fileno(stdout));
-      dup2(fileno(stderr),fileno(stdout));
-      if(strcasecmp("all",orig)==0){
-	if(int res=recursReaddirF(m,n,conf_dir,NULL,saved_stdout,0,printDescribeProcessForProcess)<0)
-	  return res;
-      }
-      else{
-	char *saveptr;
-	char *tmps=strtok_r(orig,",",&saveptr);
-	
-	char buff[256];
-	char buff1[1024];
-	while(tmps!=NULL){
-	  int hasVal=-1;
-	  char *corig=zStrdup(tmps);
-	  if(strstr(corig,".")!=NULL){
-	    
-	    parseIdentifier(m,conf_dir,corig,buff1);
-	    map* tmpMap=getMapFromMaps(m,"lenv","metapath");
-	    if(tmpMap!=NULL)
-	      addToMap(request_inputs,"metapath",tmpMap->value);
-
-	    s1=(service*)malloc(SERVICE_SIZE);
-	    t=readServiceFile(m,buff1,&s1,corig);
-	    if(t<0){
-	      map* tmp00=getMapFromMaps(m,"lenv","message");
-	      char tmp01[1024];
-	      if(tmp00!=NULL)
-		sprintf(tmp01,_("Unable to parse the ZCFG file for the following ZOO-Service: %s. Message: %s"),tmps,tmp00->value);
-	      else
-		sprintf(tmp01,_("Unable to parse the ZCFG file for the following ZOO-Service: %s."),tmps);
-	      dup2(saved_stdout,fileno(stdout));
-	      errorException(m, tmp01,"InvalidParameterValue","identifier");
-	      freeMaps(&m);
-	      free(m);
-	      free(REQUEST);
-	      free(corig);
-	      free(orig);
-	      free(SERVICE_URL);
-	      free(s1);
-	      closedir(dirp);
-	      xmlFreeDoc(doc);
-	      xmlCleanupParser();
-	      zooXmlCleanupNs();
-	      return 1;
-	    }
-#ifdef DEBUG
-	    dumpService(s1);
-#endif
-	    printDescribeProcessForProcess(m,n,s1);
-	    freeService(&s1);
-	    free(s1);
-	    s1=NULL;
-	    scount++;
-	    hasVal=1;
-	    setMapInMaps(m,"lenv","level","0");
-	  }else{
-	    memset(buff,0,256);
-	    snprintf(buff,256,"%s.zcfg",corig);
-	    memset(buff1,0,1024);
-#ifdef DEBUG
-	    printf("\n#######%s\n########\n",buff);
-#endif
-	    while ((dp = readdir(dirp)) != NULL){
-	      if( strcasecmp(dp->d_name,buff)==0 ){
-		memset(buff1,0,1024);
-		snprintf(buff1,1024,"%s/%s",conf_dir,dp->d_name);
-		s1=(service*)malloc(SERVICE_SIZE);
-		if(s1 == NULL){
-		  dup2(saved_stdout,fileno(stdout));
-		  return errorException(m, _("Unable to allocate memory."),"InternalError",NULL);
-		}
-#ifdef DEBUG
-		printf("#################\n(%s) %s\n#################\n",r_inputs->value,buff1);
-#endif
-		char *tmp0=zStrdup(dp->d_name);
-		tmp0[strlen(tmp0)-5]=0;
-		t=readServiceFile(m,buff1,&s1,tmp0);
-		free(tmp0);
-		if(t<0){
-		  map* tmp00=getMapFromMaps(m,"lenv","message");
-		  char tmp01[1024];
-		  if(tmp00!=NULL)
-		    sprintf(tmp01,_("Unable to parse the ZCFG file: %s (%s)"),dp->d_name,tmp00->value);
-		  else
-		    sprintf(tmp01,_("Unable to parse the ZCFG file: %s."),dp->d_name);
-		  dup2(saved_stdout,fileno(stdout));
-		  errorException(m, tmp01,"InternalError",NULL);
-		  freeMaps(&m);
-		  free(m);
-		  free(orig);
-		  free(REQUEST);
-		  closedir(dirp);
-		  xmlFreeDoc(doc);
-		  xmlCleanupParser();
-		  zooXmlCleanupNs();
-		  return 1;
-		}
-#ifdef DEBUG
-		dumpService(s1);
-#endif
-		printDescribeProcessForProcess(m,n,s1);
-		freeService(&s1);
-		free(s1);
-		s1=NULL;
-		scount++;
-		hasVal=1;
-	      }
-	    }
-	  }
-	  if(hasVal<0){
-	    map* tmp00=getMapFromMaps(m,"lenv","message");
-	    char tmp01[1024];
-	    if(tmp00!=NULL)
-	      sprintf(tmp01,_("Unable to parse the ZCFG file: %s (%s)"),buff,tmp00->value);
-	    else
-	      sprintf(tmp01,_("Unable to parse the ZCFG file: %s."),buff);
-	    dup2(saved_stdout,fileno(stdout));
-	    errorException(m, tmp01,"InvalidParameterValue","Identifier");
-	    freeMaps(&m);
-	    free(m);
-	    free(orig);
-	    free(REQUEST);
-	    closedir(dirp);
-	    xmlFreeDoc(doc);
-	    xmlCleanupParser();
-	    zooXmlCleanupNs();
-	    return 1;
-	  }
-	  rewinddir(dirp);
-	  tmps=strtok_r(NULL,",",&saveptr);
-	  if(corig!=NULL)
-	    free(corig);
-	}
-      }
-      closedir(dirp);
-      fflush(stdout);
-      dup2(saved_stdout,fileno(stdout));
-      free(orig);
-      printDocument(m,doc,getpid());
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      free(SERVICE_URL);
-      fflush(stdout);
+          xmlDocPtr doc = xmlNewDoc (BAD_CAST "1.0");
+          r_inputs = NULL;
+          r_inputs = getMap (request_inputs, "ServiceProvider");
+
+          xmlNodePtr n;
+          if (r_inputs != NULL)
+            n = printDescribeProcessHeader (doc, r_inputs->value, m);
+          else
+            n = printDescribeProcessHeader (doc, "", m);
+
+          r_inputs = getMap (request_inputs, "Identifier");
+
+          char *orig = zStrdup (r_inputs->value);
+
+
+          int saved_stdout = dup (fileno (stdout));
+          dup2 (fileno (stderr), fileno (stdout));
+          XML_Describe_Process (m, n, orig);
+          closedir (dirp);
+          fflush (stdout);
+          dup2 (saved_stdout, fileno (stdout));
+          free (orig);
+          printDocument (m, doc, getpid ());
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          free (SERVICE_URL);
+          fflush (stdout);
+          return 0;
+
+        }
+      else if (strncasecmp (REQUEST, "Execute", strlen (REQUEST)) != 0)
+        {
+          errorException (m,
+                          _
+                          ("Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute."),
+                          "InvalidParameterValue", "request");
+#ifdef DEBUG
+          fprintf (stderr, "No request found %s", REQUEST);
+#endif
+          closedir (dirp);
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          free (SERVICE_URL);
+          fflush (stdout);
+          return 0;
+        }
+      closedir (dirp);
+    }
+
+  s1 = NULL;
+  s1 = (service *) malloc (SERVICE_SIZE);
+  if (s1 == NULL)
+    {
+      freeMaps (&m);
+      free (m);
+      free (REQUEST);
+      free (SERVICE_URL);
+      return errorException (m, _("Unable to allocate memory."),
+                             "InternalError", NULL);
+    }
+  r_inputs = getMap (request_inputs, "MetaPath");
+  if (r_inputs != NULL)
+    snprintf (tmps1, 1024, "%s/%s", ntmp, r_inputs->value);
+  else
+    snprintf (tmps1, 1024, "%s/", ntmp);
+  r_inputs = getMap (request_inputs, "Identifier");
+  char *ttmp = zStrdup (tmps1);
+  snprintf (tmps1, 1024, "%s/%s.zcfg", ttmp, r_inputs->value);
+  free (ttmp);
+#ifdef DEBUG
+  fprintf (stderr, "Trying to load %s\n", tmps1);
+#endif
+  if (strstr (r_inputs->value, ".") != NULL)
+    {
+      char *identifier = zStrdup (r_inputs->value);
+      parseIdentifier (m, conf_dir, identifier, tmps1);
+      map *tmpMap = getMapFromMaps (m, "lenv", "metapath");
+      if (tmpMap != NULL)
+        addToMap (request_inputs, "metapath", tmpMap->value);
+      free (identifier);
+    }
+  else
+    setMapInMaps (m, "lenv", "Identifier", r_inputs->value);
+  int saved_stdout = dup (fileno (stdout));
+  dup2 (fileno (stderr), fileno (stdout));
+  t = readServiceFile (m, tmps1, &s1, r_inputs->value);
+  fflush (stdout);
+  dup2 (saved_stdout, fileno (stdout));
+  if (t < 0)
+    {
+      char *tmpMsg = (char *) malloc (2048 + strlen (r_inputs->value));
+      sprintf (tmpMsg,
+               _
+               ("The value for <indetifier> seems to be wrong (%s). Please, ensure that the process exist using the GetCapabilities request."),
+               r_inputs->value);
+      errorException (m, tmpMsg, "InvalidParameterValue", "identifier");
+      free (tmpMsg);
+      free (s1);
+      freeMaps (&m);
+      free (m);
+      free (REQUEST);
+      free (SERVICE_URL);
       return 0;
     }
-    else
-      if(strncasecmp(REQUEST,"Execute",strlen(REQUEST))!=0){
-	errorException(m, _("Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute."), "InvalidParameterValue","request");
-#ifdef DEBUG
-	fprintf(stderr,"No request found %s",REQUEST);
-#endif	
-	closedir(dirp);
-	freeMaps(&m);
-	free(m);
-	free(REQUEST);
-	free(SERVICE_URL);
-	fflush(stdout);
-	return 0;
-      }
-    closedir(dirp);
-  }
-  
-  s1=NULL;
-  s1=(service*)malloc(SERVICE_SIZE);
-  if(s1 == NULL){
-    freeMaps(&m);
-    free(m);
-    free(REQUEST);
-    free(SERVICE_URL);
-    return errorException(m, _("Unable to allocate memory."),"InternalError",NULL);
-  }
-  r_inputs=getMap(request_inputs,"MetaPath");
-  if(r_inputs!=NULL)
-    snprintf(tmps1,1024,"%s/%s",ntmp,r_inputs->value);
-  else
-    snprintf(tmps1,1024,"%s/",ntmp);
-  r_inputs=getMap(request_inputs,"Identifier");
-  char *ttmp=zStrdup(tmps1);
-  snprintf(tmps1,1024,"%s/%s.zcfg",ttmp,r_inputs->value);
-  free(ttmp);
-#ifdef DEBUG
-  fprintf(stderr,"Trying to load %s\n", tmps1);
-#endif
-  if(strstr(r_inputs->value,".")!=NULL){
-    char *identifier=zStrdup(r_inputs->value);
-    parseIdentifier(m,conf_dir,identifier,tmps1);
-    map* tmpMap=getMapFromMaps(m,"lenv","metapath");
-    if(tmpMap!=NULL)
-      addToMap(request_inputs,"metapath",tmpMap->value);
-    free(identifier);
-  }else
-    setMapInMaps(m,"lenv","Identifier",r_inputs->value);
-  int saved_stdout = dup(fileno(stdout));
-  dup2(fileno(stderr),fileno(stdout));
-  t=readServiceFile(m,tmps1,&s1,r_inputs->value);
-  fflush(stdout);
-  dup2(saved_stdout,fileno(stdout));
-  if(t<0){
-    char *tmpMsg=(char*)malloc(2048+strlen(r_inputs->value));
-    sprintf(tmpMsg,_("The value for <indetifier> seems to be wrong (%s). Please, ensure that the process exist using the GetCapabilities request."),r_inputs->value);
-    errorException(m, tmpMsg, "InvalidParameterValue","identifier");
-    free(tmpMsg);
-    free(s1);
-    freeMaps(&m);
-    free(m);
-    free(REQUEST);
-    free(SERVICE_URL);
-    return 0;
-  }
-  close(saved_stdout);
-
-#ifdef DEBUG
-  dumpService(s1);
+  close (saved_stdout);
+
+#ifdef DEBUG
+  dumpService (s1);
 #endif
   int j;
-  
+
 
   /**
    * Create the input and output maps data structure
    */
-  int i=0;
+  int i = 0;
   HINTERNET hInternet;
   HINTERNET res;
-  hInternet=InternetOpen(
+  hInternet = InternetOpen (
 #ifndef WIN32
-			 (LPCTSTR)
-#endif
-			 "ZooWPSClient\0",
-			 INTERNET_OPEN_TYPE_PRECONFIG,
-			 NULL,NULL, 0);
+                             (LPCTSTR)
+#endif
+                             "ZooWPSClient\0",
+                             INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
 
 #ifndef WIN32
-  if(!CHECK_INET_HANDLE(hInternet))
-    fprintf(stderr,"WARNING : hInternet handle failed to initialize");
-#endif
-  maps* request_input_real_format=NULL;
-  maps* tmpmaps = request_input_real_format;
-  map* postRequest=NULL;
-  postRequest=getMap(request_inputs,"xrequest");
-  if(postRequest==NULLMAP){
+  if (!CHECK_INET_HANDLE (hInternet))
+    fprintf (stderr, "WARNING : hInternet handle failed to initialize");
+#endif
+  maps *request_input_real_format = NULL;
+  maps *tmpmaps = request_input_real_format;
+  map *postRequest = NULL;
+  postRequest = getMap (request_inputs, "xrequest");
+  if (postRequest == NULLMAP)
+    {
     /**
      * Parsing outputs provided as KVP
      */
-    r_inputs=NULL;
-#ifdef DEBUG
-    fprintf(stderr,"OUTPUT Parsing ... \n");
-#endif
-    r_inputs=getMap(request_inputs,"ResponseDocument");	
-    if(r_inputs==NULL) r_inputs=getMap(request_inputs,"RawDataOutput");
-    
-#ifdef DEBUG
-    fprintf(stderr,"OUTPUT Parsing ... \n");
-#endif
-    if(r_inputs!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"OUTPUT Parsing start now ... \n");
-#endif
-      char cursor_output[10240];
-      char *cotmp=zStrdup(r_inputs->value);
-      snprintf(cursor_output,10240,"%s",cotmp);
-      free(cotmp);
-      j=0;
-	
+      r_inputs = NULL;
+#ifdef DEBUG
+      fprintf (stderr, "OUTPUT Parsing ... \n");
+#endif
+      r_inputs = getMap (request_inputs, "ResponseDocument");
+      if (r_inputs == NULL)
+        r_inputs = getMap (request_inputs, "RawDataOutput");
+
+#ifdef DEBUG
+      fprintf (stderr, "OUTPUT Parsing ... \n");
+#endif
+      if (r_inputs != NULL)
+        {
+#ifdef DEBUG
+          fprintf (stderr, "OUTPUT Parsing start now ... \n");
+#endif
+          char cursor_output[10240];
+          char *cotmp = zStrdup (r_inputs->value);
+          snprintf (cursor_output, 10240, "%s", cotmp);
+          free (cotmp);
+          j = 0;
+
       /**
        * Put each Output into the outputs_as_text array
        */
-      char * pToken;
-      maps* tmp_output=NULL;
-#ifdef DEBUG
-      fprintf(stderr,"OUTPUT [%s]\n",cursor_output);
-#endif
-      pToken=strtok(cursor_output,";");
-      char** outputs_as_text=(char**)malloc(128*sizeof(char*));
-      if(outputs_as_text == NULL) {
-	return errorException(m, _("Unable to allocate memory"), "InternalError",NULL);
-      }
-      i=0;
-      while(pToken!=NULL){
-#ifdef DEBUG
-	fprintf(stderr,"***%s***\n",pToken);
-	fflush(stderr);
-	fprintf(stderr,"***%s***\n",pToken);
-#endif
-	outputs_as_text[i]=(char*)malloc((strlen(pToken)+1)*sizeof(char));
-	if(outputs_as_text[i] == NULL) {
-	  return errorException(m, _("Unable to allocate memory"), "InternalError",NULL);
-	}
-	snprintf(outputs_as_text[i],strlen(pToken)+1,"%s",pToken);
-	pToken = strtok(NULL,";");
-	i++;
-      }
-      for(j=0;j<i;j++){
-	char *tmp=zStrdup(outputs_as_text[j]);
-	free(outputs_as_text[j]);
-	char *tmpc;
-	tmpc=strtok(tmp,"@");
-	int k=0;
-	while(tmpc!=NULL){
-	  if(k==0){
-	    if(tmp_output==NULL){
-	      tmp_output=(maps*)malloc(MAPS_SIZE);
-	      if(tmp_output == NULL){
-		return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-	      }
-	      tmp_output->name=zStrdup(tmpc);
-	      tmp_output->content=NULL;
-	      tmp_output->next=NULL;
-	    }
-	  }
-	  else{
-	    char *tmpv=strstr(tmpc,"=");
-	    char tmpn[256];
-	    memset(tmpn,0,256);
-	    strncpy(tmpn,tmpc,(strlen(tmpc)-strlen(tmpv))*sizeof(char));
-	    tmpn[strlen(tmpc)-strlen(tmpv)]=0;
-#ifdef DEBUG
-	    fprintf(stderr,"OUTPUT DEF [%s]=[%s]\n",tmpn,tmpv+1);
-#endif
-	    if(tmp_output->content==NULL){
-	      tmp_output->content=createMap(tmpn,tmpv+1);
-	      tmp_output->content->next=NULL;
-	    }
-	    else
-	      addToMap(tmp_output->content,tmpn,tmpv+1);
-	  }
-	  k++;
-#ifdef DEBUG
-	  fprintf(stderr,"***%s***\n",tmpc);
-#endif
-	  tmpc=strtok(NULL,"@");
-	}
-	if(request_output_real_format==NULL)
-	  request_output_real_format=dupMaps(&tmp_output);
-	else
-	  addMapsToMaps(&request_output_real_format,tmp_output);
-	freeMaps(&tmp_output);
-	free(tmp_output);
-	tmp_output=NULL;
-#ifdef DEBUG
-	dumpMaps(tmp_output);
-	fflush(stderr);
-#endif
-	free(tmp);
-      }
-      free(outputs_as_text);
-    }
+          char *pToken;
+          maps *tmp_output = NULL;
+#ifdef DEBUG
+          fprintf (stderr, "OUTPUT [%s]\n", cursor_output);
+#endif
+          pToken = strtok (cursor_output, ";");
+          char **outputs_as_text = (char **) malloc (128 * sizeof (char *));
+          if (outputs_as_text == NULL)
+            {
+              return errorException (m, _("Unable to allocate memory"),
+                                     "InternalError", NULL);
+            }
+          i = 0;
+          while (pToken != NULL)
+            {
+#ifdef DEBUG
+              fprintf (stderr, "***%s***\n", pToken);
+              fflush (stderr);
+              fprintf (stderr, "***%s***\n", pToken);
+#endif
+              outputs_as_text[i] =
+                (char *) malloc ((strlen (pToken) + 1) * sizeof (char));
+              if (outputs_as_text[i] == NULL)
+                {
+                  return errorException (m, _("Unable to allocate memory"),
+                                         "InternalError", NULL);
+                }
+              snprintf (outputs_as_text[i], strlen (pToken) + 1, "%s",
+                        pToken);
+              pToken = strtok (NULL, ";");
+              i++;
+            }
+          for (j = 0; j < i; j++)
+            {
+              char *tmp = zStrdup (outputs_as_text[j]);
+              free (outputs_as_text[j]);
+              char *tmpc;
+              tmpc = strtok (tmp, "@");
+              int k = 0;
+              while (tmpc != NULL)
+                {
+                  if (k == 0)
+                    {
+                      if (tmp_output == NULL)
+                        {
+                          tmp_output = (maps *) malloc (MAPS_SIZE);
+                          if (tmp_output == NULL)
+                            {
+                              return errorException (m,
+                                                     _
+                                                     ("Unable to allocate memory."),
+                                                     "InternalError", NULL);
+                            }
+                          tmp_output->name = zStrdup (tmpc);
+                          tmp_output->content = NULL;
+                          tmp_output->next = NULL;
+                        }
+                    }
+                  else
+                    {
+                      char *tmpv = strstr (tmpc, "=");
+                      char tmpn[256];
+                      memset (tmpn, 0, 256);
+                      strncpy (tmpn, tmpc,
+                               (strlen (tmpc) -
+                                strlen (tmpv)) * sizeof (char));
+                      tmpn[strlen (tmpc) - strlen (tmpv)] = 0;
+#ifdef DEBUG
+                      fprintf (stderr, "OUTPUT DEF [%s]=[%s]\n", tmpn,
+                               tmpv + 1);
+#endif
+                      if (tmp_output->content == NULL)
+                        {
+                          tmp_output->content = createMap (tmpn, tmpv + 1);
+                          tmp_output->content->next = NULL;
+                        }
+                      else
+                        addToMap (tmp_output->content, tmpn, tmpv + 1);
+                    }
+                  k++;
+#ifdef DEBUG
+                  fprintf (stderr, "***%s***\n", tmpc);
+#endif
+                  tmpc = strtok (NULL, "@");
+                }
+              if (request_output_real_format == NULL)
+                request_output_real_format = dupMaps (&tmp_output);
+              else
+                addMapsToMaps (&request_output_real_format, tmp_output);
+              freeMaps (&tmp_output);
+              free (tmp_output);
+              tmp_output = NULL;
+#ifdef DEBUG
+              dumpMaps (tmp_output);
+              fflush (stderr);
+#endif
+              free (tmp);
+            }
+          free (outputs_as_text);
+        }
 
 
